ifndef HARDHAT_BASE
###############################################################################
# PC Linux
TARGET_MACHINE  =
CROSS_COMPILE   =
ARCH_FLAGS		=
LINUX = /usr/src/linux-2.4
# PC Linux
###############################################################################
else
###############################################################################
# XScale Linux
TARGET_MACHINE  =xscale_be
ARCH            = arm
TOOLS_PREFIX    =$(HARDHAT_BASE)/devkit/$(ARCH)/$(TARGET_MACHINE)
export CROSS_COMPILE=$(TARGET_MACHINE)-
export TOOLS_PREFIX_BIN=$(TOOLS_PREFIX)/bin/
export PATH:=$(PATH):$(TOOLS_PREFIX_BIN)

ARCH_FLAGS = \
    -mbig-endian \
    -mapcs-32 \
    -mtune=strongarm \
    -fomit-frame-pointer \
    -fno-builtin \
    -mshort-load-bytes \
    -march=armv4 \
    -static \
    -DMACH_IXP425

LINUX = $(TOPDIR)
# XScale Linux
###############################################################################
endif

AS      = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)as
LD      = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)ld
CC      = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)gcc
CPP     = $(CC) -E
AR      = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)ar
NM      = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)nm
STRIP   = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)strip
OBJCOPY = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)objcopy
OBJDUMP = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)objdump
PERL    = perl
RANLIB  = $(TOOLS_PREFIX_BIN)$(CROSS_COMPILE)ranlib

CFLAGS += -pipe -Wall -O3 -Os -Wstrict-prototypes
CFLAGS +=$(ARCH_FLAGS)
CFLAGS +=-D$(OEM)

ifeq ($(OEM), WG302)
CFLAGS +=-DNETGEAR
endif

ifeq ($(OEM), WAG302)
CFLAGS +=-DNETGEAR
endif

ifeq ($(OEM), BWA7090)
CFLAGS +=-DAG3120
endif

ifeq ($(OEM), BWA8110A)
CFLAGS +=-DAG3120
endif
