// wag302def.h
//

#ifndef	__WAG302DEF_H__
#define	__WAG302DEF_H__

#include <stdint.h>

///////////////////////////////////////////////////////////////////////////////
//	Detailed definitions
///////////////////////////////////////////////////////////////////////////////
//MIB_PRODUCT
typedef enum Product_t
{
	PRODUCT_AUTO	= 0,
	PRODUCT_WG302	= 302,
	PRODUCT_WAG302,
	PRODUCT_XA3120	= 3120,
	PRODUCT_XG3120,
	PRODUCT_AG3220,
	PRODUCT_BWA7090,
	PRODUCT_ZA5000	= 5000,
	PRODUCT_ZG5000,
	PRODUCT_ZA5000E1,
	PRODUCT_ZA5000D,
	PRODUCT_ZA5000EW,
	PRODUCT_BWA9100A,
	PRODUCT_BWA9110A,
	PRODUCT_BWA9100G,
	PRODUCT_BWA9110G,
	PRODUCT_BWA8110A= 8110
} Product_t;

typedef	enum IPStr_t
{
	IP_STR_MIN_LEN = 8,	// includes '\0'
	IP_STR_MAX_LEN = 16	// includes '\0'
} IPStr_t;

//MIB_FILE_ACCESS_START && MIB_FILE_ACCESS_FINISH
typedef	enum FileAccessIndex_t
{
	FILE_ACCESS_CONFIG = 0,		// read/write
	FILE_ACCESS_FIRMWARE,		// write-only
	FILE_ACCESS_VERSION,		// read-only
	FILE_ACCESS_CLIENT_LIST,	// read-only
	FILE_ACCESS_SNMP_MIB,		// read-only
	FILE_ACCESS_FACTORY_SETTING,// read/write

	FILE_ACCESS_LAST
} FileAccessIndex_t;

typedef	enum RadiusIndex_t
{
	RADIUS_AUTH_PRIMARY =0,
	RADIUS_AUTH_SECONDARY,
	RADIUS_ACCOUNT_PRIMARY,
	RADIUS_ACCOUNT_SECONDARY,
	RADIUS_LAST
} RadiusIndex_t;

///////////////////////////////////////////////////////////////////////////////
// AutoCell definitions
///////////////////////////////////////////////////////////////////////////////
//MIB_RF_COVERAGE
typedef	enum RFCoverage_t
{
	RF_COVERAGE_STANDARD = 0,
	RF_COVERAGE_SHAPED,
	RF_COVERAGE_WHISPER,
	RF_COVERAGE_STEALTH
} RFCoverage_t;

//MIB_PROBE_MODE
typedef	enum ACProbeMode_t
{
	AC_PROBE_DISABLE	= 0,
	AC_PROBE_DEDICATED,
	AC_PROBE_BACKGROUND
} ACProbeMode_t;

///////////////////////////////////////////////////////////////////////////////
// Host Networking definitions
///////////////////////////////////////////////////////////////////////////////
#if defined(AG3120) || defined(ZAG5000)
typedef	enum DevPortIndex_t
{
	DEV_PORT_BRIDGE	= 0,
	DEV_PORT_ETH,
	DEV_PORT_WLAN,
	DEV_PORT_LAST
} DevPortIndex_t;

typedef	enum RouteMode_t
{
	BRIDGE_MODE	= 0,
	ROUTE_MODE_WAN_ETH,
	ROUTE_MODE_WAN_WLAN
} RouteMode_t;

typedef	enum IPType_t
{
	IP_TYPE_STATIC_IP=0,
	IP_TYPE_DHCP_CLIENT,
	IP_TYPE_DHCP_SERVER
} IPType_t;
#endif//AG3120 || ZAG5000

#if defined(AG3120)
//MIB_WLAN_AP_SCAN
#define	AP_SCAN_STOP	0
#define	AP_SCAN_START	1
#endif//AG3120

///////////////////////////////////////////////////////////////////////////////
// Wireless definitions
///////////////////////////////////////////////////////////////////////////////
//MIB_WLAN_OPERATION_MODE
typedef	enum WlanOperationMode_t
{
	WLAN_OPERATION_AP = 0,
	WLAN_OPERATION_AP_CLIENT,
	WLAN_OPERATION_P2P,
	WLAN_OPERATION_P2P_AP,
	WLAN_OPERATION_P2MP,
	WLAN_OPERATION_P2MP_AP,
	WLAN_OPERATION_REPEATER,
	WLAN_OPERATION_AUTOWDS,
} WlanOperationMode_t;

//MIB_WLAN_WIRELESS_MODE
typedef	enum WlanWirelessMode_t
{
	WIRELESS_MODE_AUTO = 0,		// 11b/g auto
	WIRELESS_MODE_11A,
	WIRELESS_MODE_11B_ONLY,
	WIRELESS_MODE_11G_ONLY,
	WIRELESS_MODE_11A_TURBO,
} WlanWirelessMode_t;

//MIB_WLAN_TRANSMIT_POWER
typedef	enum TransmitPower_t
{
	TX_POWER_FULL = 0,
	TX_POWER_HALF,
	TX_POWER_QUARTER,
	TX_POWER_EIGHTH,
	TX_POWER_MIN
} TransmitPower_t;

//MIB_WLAN_PREAMBLE
typedef	enum Preamble_t
{
	PREAMBLE_LONG = 0,
	PREAMBLE_SHORT		// auto
} Preamble_t;

//MIB_WLAN_ANTENNA
typedef	enum Antenna_t
{
	ANTENNA_AUTO = 0,
	ANTENNA_PRIMARY,
	ANTENNA_SECONDARY
} Antenna_t;

//MIB_WLAN_ACL_MODE
typedef	enum ACLMode_t
{
	ACL_MODE_DISABLE = 0,
	ACL_MODE_ENABLE,
	ACL_MODE_STRICT,
	ACL_MODE_SERVER,
} ACLMode_t;

//MIB_WLAN_SUPPORTED_XPD_GAIN
typedef	enum XPDGainInfo_t
{
#ifndef	XPD_GAIN0
	XPD_GAIN0	= 0x00000001,
	XPD_GAIN6	= 0x00000002,
	XPD_GAIN12	= 0x00000004,
	XPD_GAIN18	= 0x00000008,
#endif//!XPD_GAIN0
	XPD_11B_SHIFT = 0,
	XPD_11G_SHIFT = 8,
	XPD_11A_SHIFT = 16
} XPDGainInfo_t;

//MIB_WLAN_AUTHENTICATION
typedef enum Authentication_t
{
	AUTH_OPEN_SYSTEM	= 0x00,
	AUTH_SHARED_KEY		= 0x01,
	AUTH_802_1X			= 0x02,
	AUTH_WPA_RADIUS		= 0x04,
	AUTH_WPA2_RADIUS	= 0x08,
	AUTH_WPA1_2_RADIUS	= (AUTH_WPA_RADIUS|AUTH_WPA2_RADIUS),
	AUTH_WPA_PSK		= 0x10,
	AUTH_WPA2_PSK		= 0x20,
	AUTH_WPA1_2_PSK		= (AUTH_WPA_PSK|AUTH_WPA2_PSK),
	AUTH_ALL			= (AUTH_OPEN_SYSTEM|AUTH_SHARED_KEY|AUTH_802_1X
						  |AUTH_WPA1_2_RADIUS|AUTH_WPA1_2_PSK),
} Authentication_t;

//MIB_WLAN_ENCRYPTION
typedef enum Encryption_t
{
	ENCRYPT_NONE		= 0x00,
	ENCRYPT_WEP			= 0x01,
	ENCRYPT_TKIP		= 0x02,
	ENCRYPT_AES			= 0x04,
	ENCRYPT_AES_TKIP	= (ENCRYPT_TKIP|ENCRYPT_AES),
} Encryption_t;

//MIB_WEP_KEY_TYPE
typedef	enum WepKeyType_t
{
	// the first three types are for internal using.
	WEP_KEY_HEX			= 0,
	WEP_KEY_ALPHA,
	WEP_KEY_PHRASE,

	WEP_KEY_64HEX		= 40,
	WEP_KEY_64ALPHA,
	WEP_KEY_64PHRASE,
	WEP_KEY_128HEX		= 104,
	WEP_KEY_128ALPHA,
	WEP_KEY_128PHRASE,
	WEP_KEY_152HEX		= 128,
	WEP_KEY_152ALPHA,
	WEP_KEY_152PHRASE
} WepKeyType_t;

//MIB_WPA_GKEY_UPDATE_CONDITION
typedef	enum WPA_GKeyUpdateCondition_t
{
	WPA_GKEY_UPDATE_NEVER =0,
	WPA_GKEY_UPDATE_SECONDS,			// re-groupkey, after specified seconds.
	WPA_GKEY_UPDATE_PACKETS,			// re-groupkey, after specified packets.
	WPA_GKEY_UPDATE_DISCONNECT = 0x80,	// re-groupkey, after client disconnected.
										// can combine with SECONDS/PACKETS
	WPA_GKEY_UPDATE_SECONDS_DISCONNECT
			= (WPA_GKEY_UPDATE_SECONDS|WPA_GKEY_UPDATE_DISCONNECT),
	WPA_GKEY_UPDATE_PACKETS_DISCONNECT
			= (WPA_GKEY_UPDATE_PACKETS|WPA_GKEY_UPDATE_DISCONNECT),
} WPA_GKeyUpdateCondition_t;

#ifdef	WIN32
// Forrest: the following definitions conflict with "WINNLS.H"
#undef CTRY_DEFAULT

#undef CTRY_ALBANIA
#undef CTRY_ALGERIA
#undef CTRY_ARGENTINA
#undef CTRY_AUSTRALIA
#undef CTRY_AUSTRIA
#undef CTRY_BAHRAIN
#undef CTRY_BELARUS
#undef CTRY_BELGIUM
#undef CTRY_BELIZE
#undef CTRY_BOLIVIA
#undef CTRY_BRAZIL
#undef CTRY_BRUNEI_DARUSSALAM
#undef CTRY_BULGARIA
#undef CTRY_CANADA
#undef CTRY_CARIBBEAN
#undef CTRY_CHILE
#undef CTRY_COLOMBIA
#undef CTRY_COSTA_RICA
#undef CTRY_CROATIA
#undef CTRY_CZECH
#undef CTRY_DENMARK
#undef CTRY_DOMINICAN_REPUBLIC
#undef CTRY_ECUADOR
#undef CTRY_EGYPT
#undef CTRY_EL_SALVADOR
#undef CTRY_ESTONIA
#undef CTRY_FAEROE_ISLANDS
#undef CTRY_FINLAND
#undef CTRY_FRANCE
#undef CTRY_GERMANY
#undef CTRY_GREECE
#undef CTRY_GUATEMALA
#undef CTRY_HONDURAS
#undef CTRY_HONG_KONG
#undef CTRY_HUNGARY
#undef CTRY_ICELAND
#undef CTRY_INDIA
#undef CTRY_INDONESIA
#undef CTRY_IRAN
#undef CTRY_IRAQ
#undef CTRY_IRELAND
#undef CTRY_ISRAEL
#undef CTRY_ITALY
#undef CTRY_JAMAICA
#undef CTRY_JAPAN
#undef CTRY_JORDAN
#undef CTRY_KENYA
#undef CTRY_KUWAIT
#undef CTRY_LATVIA
#undef CTRY_LEBANON
#undef CTRY_LIBYA
#undef CTRY_LIECHTENSTEIN
#undef CTRY_LITHUANIA
#undef CTRY_LUXEMBOURG
#undef CTRY_MACAU
#undef CTRY_MACEDONIA
#undef CTRY_MALAYSIA
#undef CTRY_MEXICO
#undef CTRY_MONACO
#undef CTRY_MOROCCO
#undef CTRY_NETHERLANDS
#undef CTRY_NEW_ZEALAND
#undef CTRY_NICARAGUA
#undef CTRY_NORWAY
#undef CTRY_OMAN
#undef CTRY_PAKISTAN
#undef CTRY_PANAMA
#undef CTRY_PARAGUAY
#undef CTRY_PERU
#undef CTRY_PHILIPPINES
#undef CTRY_POLAND
#undef CTRY_PORTUGAL
#undef CTRY_PRCHINA
#undef CTRY_PUERTO_RICO
#undef CTRY_QATAR
#undef CTRY_ROMANIA
#undef CTRY_RUSSIA
#undef CTRY_SAUDI_ARABIA
#undef CTRY_SERBIA
#undef CTRY_SINGAPORE
#undef CTRY_SLOVAK
#undef CTRY_SLOVENIA
#undef CTRY_SOUTH_AFRICA
#undef CTRY_SOUTH_KOREA
#undef CTRY_SPAIN
#undef CTRY_SWEDEN
#undef CTRY_SWITZERLAND
#undef CTRY_SYRIA
#undef CTRY_TAIWAN
#undef CTRY_THAILAND
#undef CTRY_TRINIDAD_Y_TOBAGO
#undef CTRY_TUNISIA
#undef CTRY_TURKEY
#undef CTRY_UAE
#undef CTRY_UKRAINE
#undef CTRY_UNITED_KINGDOM
#undef CTRY_UNITED_STATES
#undef CTRY_URUGUAY
#undef CTRY_VENEZUELA
#undef CTRY_VIET_NAM
#undef CTRY_YEMEN
#undef CTRY_ZIMBABWE
#endif//WIN32

//MIB_SYS_COUNTRY
typedef enum Country_t
{
    CTRY_ALBANIA              = 8,       // Albania
    CTRY_ALGERIA              = 12,      // Algeria
    CTRY_ARGENTINA            = 32,      // Argentina
    CTRY_ARMENIA              = 51,      // Armenia
    CTRY_AUSTRALIA            = 36,      // Australia
    CTRY_AUSTRIA              = 40,      // Austria
    CTRY_AZERBAIJAN           = 31,      // Azerbaijan
    CTRY_BAHRAIN              = 48,      // Bahrain
    CTRY_BELARUS              = 112,     // Belarus
    CTRY_BELGIUM              = 56,      // Belgium
    CTRY_BELIZE               = 84,      // Belize
    CTRY_BOLIVIA              = 68,      // Bolivia
    CTRY_BRAZIL               = 76,      // Brazil
    CTRY_BRUNEI_DARUSSALAM    = 96,      // Brunei Darussalam
    CTRY_BULGARIA             = 100,     // Bulgaria
    CTRY_CANADA               = 124,     // Canada
    CTRY_CHILE                = 152,     // Chile
    CTRY_CHINA                = 156,     // People's Republic of China
    CTRY_COLOMBIA             = 170,     // Colombia
    CTRY_COSTA_RICA           = 188,     // Costa Rica
    CTRY_CROATIA              = 191,     // Croatia
    CTRY_CYPRUS               = 196,
    CTRY_CZECH                = 203,     // Czech Republic
    CTRY_DENMARK              = 208,     // Denmark
    CTRY_DOMINICAN_REPUBLIC   = 214,     // Dominican Republic
    CTRY_ECUADOR              = 218,     // Ecuador
    CTRY_EGYPT                = 818,     // Egypt
    CTRY_EL_SALVADOR          = 222,     // El Salvador
    CTRY_ESTONIA              = 233,     // Estonia
    CTRY_FAEROE_ISLANDS       = 234,     // Faeroe Islands
    CTRY_FINLAND              = 246,     // Finland
    CTRY_FRANCE               = 250,     // France
    CTRY_GEORGIA              = 268,     // Georgia
    CTRY_GERMANY              = 276,     // Germany
    CTRY_GREECE               = 300,     // Greece
    CTRY_GUATEMALA            = 320,     // Guatemala
    CTRY_HONDURAS             = 340,     // Honduras
    CTRY_HONG_KONG            = 344,     // Hong Kong S.A.R., P.R.C.
    CTRY_HUNGARY              = 348,     // Hungary
    CTRY_ICELAND              = 352,     // Iceland
    CTRY_INDIA                = 356,     // India
    CTRY_INDONESIA            = 360,     // Indonesia
    CTRY_IRAN                 = 364,     // Iran
    CTRY_IRAQ                 = 368,     // Iraq
    CTRY_IRELAND              = 372,     // Ireland
    CTRY_ISRAEL               = 376,     // Israel
    CTRY_ITALY                = 380,     // Italy
    CTRY_JAMAICA              = 388,     // Jamaica
    CTRY_JAPAN                = 392,     // Japan
    CTRY_JAPAN1               = 393,     // Japan (JP1)
    CTRY_JAPAN2               = 394,     // Japan (JP0)
    CTRY_JAPAN3               = 395,     // Japan (JP1-1)
    CTRY_JAPAN4               = 396,     // Japan (JE1)
    CTRY_JAPAN5               = 397,     // Japan (JE2)   
    CTRY_JORDAN               = 400,     // Jordan
    CTRY_KAZAKHSTAN           = 398,     // Kazakhstan
    CTRY_KENYA                = 404,     // Kenya
    CTRY_KOREA_NORTH          = 408,     // North Korea
    CTRY_KOREA_ROC            = 410,     // South Korea
    CTRY_KOREA_ROC2           = 411,     // South Korea
    CTRY_KUWAIT               = 414,     // Kuwait
    CTRY_LATVIA               = 428,     // Latvia
    CTRY_LEBANON              = 422,     // Lebanon
    CTRY_LIBYA                = 434,     // Libya
    CTRY_LIECHTENSTEIN        = 438,     // Liechtenstein
    CTRY_LITHUANIA            = 440,     // Lithuania
    CTRY_LUXEMBOURG           = 442,     // Luxembourg
    CTRY_MACAU                = 446,     // Macau
    CTRY_MACEDONIA            = 807,     // the Former Yugoslav Republic of Macedonia
    CTRY_MALAYSIA             = 458,     // Malaysia
    CTRY_MEXICO               = 484,     // Mexico
    CTRY_MONACO               = 492,     // Principality of Monaco
    CTRY_MOROCCO              = 504,     // Morocco
    CTRY_NETHERLANDS          = 528,     // Netherlands
    CTRY_NEW_ZEALAND          = 554,     // New Zealand
    CTRY_NICARAGUA            = 558,     // Nicaragua
    CTRY_NORWAY               = 578,     // Norway
    CTRY_OMAN                 = 512,     // Oman
    CTRY_PAKISTAN             = 586,     // Islamic Republic of Pakistan
    CTRY_PANAMA               = 591,     // Panama
    CTRY_PARAGUAY             = 600,     // Paraguay
    CTRY_PERU                 = 604,     // Peru
    CTRY_PHILIPPINES          = 608,     // Republic of the Philippines
    CTRY_POLAND               = 616,     // Poland
    CTRY_PORTUGAL             = 620,     // Portugal
    CTRY_PUERTO_RICO          = 630,     // Puerto Rico
    CTRY_QATAR                = 634,     // Qatar
    CTRY_ROMANIA              = 642,     // Romania
    CTRY_RUSSIA               = 643,     // Russia
    CTRY_SAUDI_ARABIA         = 682,     // Saudi Arabia
    CTRY_SINGAPORE            = 702,     // Singapore
    CTRY_SLOVAKIA             = 703,     // Slovak Republic
    CTRY_SLOVENIA             = 705,     // Slovenia
    CTRY_SOUTH_AFRICA         = 710,     // South Africa
    CTRY_SPAIN                = 724,     // Spain
    CTRY_SWEDEN               = 752,     // Sweden
    CTRY_SWITZERLAND          = 756,     // Switzerland
    CTRY_SYRIA                = 760,     // Syria
    CTRY_TAIWAN               = 158,     // Taiwan
    CTRY_THAILAND             = 764,     // Thailand
    CTRY_TRINIDAD_Y_TOBAGO    = 780,     // Trinidad y Tobago
    CTRY_TUNISIA              = 788,     // Tunisia
    CTRY_TURKEY               = 792,     // Turkey
    CTRY_UAE                  = 784,     // U.A.E.
    CTRY_UKRAINE              = 804,     // Ukraine
    CTRY_UNITED_KINGDOM       = 826,     // United Kingdom
    CTRY_UNITED_STATES        = 840,     // United States
    CTRY_URUGUAY              = 858,     // Uruguay
    CTRY_UZBEKISTAN           = 860,     // Uzbekistan
    CTRY_VENEZUELA            = 862,     // Venezuela
    CTRY_VIET_NAM             = 704,     // Viet Nam
    CTRY_YEMEN                = 887,     // Yemen
    CTRY_ZIMBABWE             = 716      // Zimbabwe
} Country_t;

///////////////////////////////////////////////////////////////////////////////
// Structure definitions
///////////////////////////////////////////////////////////////////////////////
//MIB_ETHERNET_STATS & MIB_WLAN_STATS
typedef	struct NetDeviceStats_t
{
	struct Stats_t
	{
		uint64_t	ullBytes;
		
		uint64_t	ullPacketsTotal;
		uint64_t	ullPacketsUnicast;
		uint64_t	ullPacketsMulticast;
		uint64_t	ullPacketsBroadcast;

		uint32_t	ulPacketsError;
		uint32_t	ulPacketsDropped;
	} Rx, Tx;
} NetDeviceStats_t;

#if	defined(AG3120)
typedef	struct
{
	int32_t			lindex;
	int32_t			dbm;
	uint32_t		channel;	
	uint32_t		wirelessmode;
	uint8_t			ssid[36];	//Max string length is 32 
	uint32_t		isWEP;
	char			bssid[18];
} ApScanList_t;

typedef struct
{
	int32_t				lIndex;
	char				szMacAddr[18];
	char				szIPAddr[16];
	uint32_t			ulLastUpdateTime;
	int32_t				lRssi;
	int32_t				ldBm;
	WlanWirelessMode_t	WirelessMode;
} RemoteApInfo_t;

typedef	struct
{
	int32_t			lIndex;
	char			BridgeMac[18];
	// Action
#define	BRIDGE_ACTION_APPEND		0x40000000L
#define	BRIDGE_ACTION_REMOVE_ONE	0x80000000L
#define	BRIDGE_ACTION_REMOVE_ALL	0xF0000000L
	// Status
#define	BRIDGE_STATUS_UNKNOWN	0
#define	BRIDGE_STATUS_INACTIVE	1
#define	BRIDGE_STATUS_ACTIVE	2
	uint32_t		ulStatusOrAction;
	int32_t			dbm;
} BridgeList_t;

#endif//AG3120

#endif//!__WAG302DEF_H__
