//
//	zcomlog.h
//		Copyright (c) 2003, Z-Com, Inc.	
//		Forrest	<Team@zcom.com.cn>
//				<HappyDogs@zcom.unimis.com>
//

#ifndef	_ZCOM_LOG_H_
#define	_ZCOM_LOG_H_

#define	ZCOM_PROC_FILE_NAME			"syslog"
#define	ZCOM_PROC_FILE_NAME_REVERSE	"syslog_rev"
#define	ZCOM_LOG_QUEUE_SIZE	16384	// ZCOM_LOG_QUEUE_SIZE bytes
									// Min size is 256 bytes

typedef	enum ZComLogID_t
{
	// padding log
	ZCOM_LOG_PADDING,	// don't use this ID.
	// generic log,	ZComLogRecord.u.szGeneric
	ZCOM_LOG_GENERIC,
	// system log
	ZCOM_LOG_SYS_BOOT_UP,
	ZCOM_LOG_SYS_SHUT_DOWN,
	// wlan log, ZComLogRecord.u.WlanLog
	ZCOM_LOG_WLAN_UP,
	ZCOM_LOG_WLAN_DOWN,
	ZCOM_LOG_WLAN_INTERFERENCE,
	ZCOM_LOG_WLAN_MIC_FAILED,
	ZCOM_LOG_WLAN_MIC_ATTACKED,
	ZCOM_LOG_WLAN_AUTHENTICATED,
	ZCOM_LOG_WLAN_AUTHENTICATION_FAIL,
	ZCOM_LOG_WLAN_DEAUTHENTICATED,
	ZCOM_LOG_WLAN_KEY_MISMATCHED,
	ZCOM_LOG_WLAN_ASSOCIATED,
	ZCOM_LOG_WLAN_REASSOCIATED,
	ZCOM_LOG_WLAN_ASSOCIATION_FAIL,
	ZCOM_LOG_WLAN_DISASSOCIATED,
	ZCOM_LOG_WLAN_ACL_REFUSE,
	ZCOM_LOG_WLAN_REMOTE_AP_JOINED,
	// cli log, ZComLogRecord.u.AuthorizationLog
	ZCOM_LOG_CLI_AUTHORIZED,
	ZCOM_LOG_CLI_UNAUTHORIZED,
	ZCOM_LOG_CLI_LOGOUT,
	// web log, ZComLogRecord.u.AuthorizationLog
	ZCOM_LOG_WEB_AUTHORIZED,
	ZCOM_LOG_WEB_UNAUTHORIZED,
	ZCOM_LOG_WEB_LOGOUT,
	// snmp log, ZComLogRecord.u.AuthorizationLog
	ZCOM_LOG_SNMP_BAD_COMMUNITY	//???
} ZComLogID_t;

typedef	enum ZComLogIDRange{
	ZCOM_LOG_FIRST_ID				= ZCOM_LOG_GENERIC,
	ZCOM_LOG_LAST_ID				= ZCOM_LOG_SNMP_BAD_COMMUNITY,

	ZCOM_LOG_WLAN_FIRST_ID			= ZCOM_LOG_WLAN_UP,
	ZCOM_LOG_WLAN_LAST_ID			= ZCOM_LOG_WLAN_REMOTE_AP_JOINED,

	ZCOM_LOG_AUTHORIZATION_FIRST_ID	= ZCOM_LOG_CLI_AUTHORIZED,
	ZCOM_LOG_AUTHORIZATION_LAST_ID	= ZCOM_LOG_WEB_LOGOUT,
} ZComLogIDRange;

void ZComLogAppendGeneric(char *szGeneric);

void 
ZComLogAppendAuthorization(
	unsigned short	usIdentification,	// refer to ZComLogID
	unsigned char	puchFromIPv4[4],	// IP Address
	unsigned char	*szUserName			// Authorization User name
	);

#ifdef	__KERNEL__// kernel space
void
ZComLogAppendWlan(
	unsigned short	usIdentification,	// refer to ZComLogID
	unsigned char	uchWlanId,			// 0 for eth0, 1 for eth1
	unsigned char	uchWlanMode,		// 802.11g/802.11a
	unsigned char	puchMacAddress[6]
	);
#endif//__KERNEL__

#endif//_ZCOM_LOG_H_
