// zcommisc.h
//

#ifndef	__ZCOMMISC_H__
#define	__ZCOMMISC_H__

#define	ZCOM_MISC_NAME		"zcommisc"
#define	ZCOM_MISC_FULLNAME	"/dev/"ZCOM_MISC_NAME

typedef	enum ZComMiscID_t
{
	// Time and time zone IDs
	ZCOM_MISC_TIME_FIRST_ID	= 0,
	ZMG_TIME_ZONE_LIST		= ZCOM_MISC_TIME_FIRST_ID,
	ZMG_TIME_ZONE,
	ZMS_TIME_ZONE,
	ZMG_TIME_DST,
	ZMS_TIME_DST,
	ZMG_TIME_NOW,			// return long
	ZMG_TIME_NOW_STRING,	// return char*
	ZCOM_MISC_TIME_LAST_ID,

	// GPIO IDs
	ZCOM_MISC_GPIO_FIRST_ID = ZCOM_MISC_TIME_LAST_ID,
	ZCOM_MISC_GPIO_GET		= ZCOM_MISC_GPIO_FIRST_ID,
	ZCOM_MISC_GPIO_SET,
	ZCOM_MISC_GPIO_LAST_ID,

	// Boot Config IDs
	ZCOM_MISC_BOOT_FIRST_ID = ZCOM_MISC_GPIO_LAST_ID,
	ZCOM_MISC_BOOT_MAC_ADDR	= ZCOM_MISC_BOOT_FIRST_ID,	// return 6 octets
	ZCOM_MISC_BOOT_DEF_COUNTRY,		// return long
	ZCOM_MISC_BOOT_IS_OUTDOOR,		// return long
	ZCOM_MISC_BOOT_PRODUCT_NAME,	// return char[128]
	ZCOM_MISC_BOOT_RF_CUSTOM,		// return char[128]
	ZCOM_MISC_BOOT_UPDATE,
	ZCOM_MISC_BOOT_LAST_ID,

} ZComMiscID_t;

typedef	enum ZComGpioLine_t
{
	// LED: gpio out
	GPIO_LED_POWER	= 0,
	GPIO_RF_SIGNAL0	= 1,
	GPIO_RF_SIGNAL1	= 2,
	GPIO_RF_SIGNAL2	= 3,
	GPIO_LED_TEST	= 4,
	GPIO_LED_WLAN_G	= 5,
	GPIO_LED_WLAN_A	= 6,
	GPIO_BUZZER		= 6,
	// Button: gpio in
	GPIO_BTN_DEFAULT= 13,
} ZComGpioLine_t;

typedef	enum ZComGpioStatus_t
{
	GPIO_BTN_PRESSED	= 0,	//IXP425_GPIO_LOW
	GPIO_BTN_RELEASED	= 1,	//IXP425_GPIO_HIGH

	GPIO_LED_ON			= 0,	//IXP425_GPIO_LOW
	GPIO_LED_OFF		= 1,	//IXP425_GPIO_HIGH
} ZComGpioStatus_t;

typedef	struct ZComGpioIoReq_t
{
	uint32_t	ulGpioLine;	//ZComGpioLine_t
	uint32_t	ulStatus;	//ZComGpioStatus_t
	union
	{
		uint32_t	ulBtnDuration;	// Button Status Duration in millisecond.
		struct
		{
#define	ZCOM_LED_BLINK_NEVER	0
			uint32_t	ulLedBlinkPeriod;	//in millisecond. if !0 blink
#define	ZCOM_LED_BLINK_FOREVER	0
			uint32_t	ulLedBlinkTimes;	//0 always blink, 
											//else blink ulTimes then off
		};
	};
} ZComGpioIoReq_t;

#endif//!__ZCOMMISC_H__
